package mod.mcreator;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.ForgeRegistries;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.BlockFluidClassic;
import net.minecraftforge.client.model.ModelLoader;

import net.minecraft.world.World;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.ResourceLocation;
import net.minecraft.server.MinecraftServer;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.Item;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.block.statemap.StateMapperBase;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.renderer.block.model.ModelBakery;
import net.minecraft.client.renderer.ItemMeshDefinition;
import net.minecraft.block.state.IBlockState;
import net.minecraft.block.material.Material;

import java.util.Random;
import java.util.HashMap;

public class mcreator_bucketOfThunder {

	public static Object instance;
	static {
		FluidRegistry.enableUniversalBucket();
	}

	public mcreator_bucketOfThunder() {
	}

	public static BlockFluidClassic block = null;
	public static Item item = null;

	public void preInit(FMLPreInitializationEvent event) {
		ResourceLocation still = new ResourceLocation("blocks/movingliquidone");
		ResourceLocation flowing = new ResourceLocation("blocks/movingliquidtwo");
		Fluid fluid = new Fluid("bucketofthunder", still, flowing).setLuminosity(0).setDensity(1000).setViscosity(1500).setGaseous(false);
		FluidRegistry.registerFluid(fluid);
		FluidRegistry.addBucketForFluid(fluid);
		block = new BlockFluidClassic(fluid, Material.WATER) {

			@Override
			public void onEntityCollidedWithBlock(World world, BlockPos pos, IBlockState state, Entity entity) {
				super.onEntityCollidedWithBlock(world, pos, state, entity);
				int i = pos.getX();
				int j = pos.getY();
				int k = pos.getZ();
				java.util.HashMap<String, Object> dependencies = new java.util.HashMap<>();
				dependencies.put("x", i);
				dependencies.put("y", j);
				dependencies.put("z", k);
				dependencies.put("world", world);
				dependencies.put("entity", entity);
				dependencies.put("block", block);
				mcreator_weakexplosion.executeProcedure(dependencies);
			}
		};
		block.setUnlocalizedName("bucketOfThunder");
		block.setRegistryName("fluid." + block.getFluid().getName());
		ForgeRegistries.BLOCKS.register(block);
		item = new ItemBlock(block);
		item.setRegistryName("bucketOfThunder");
		ForgeRegistries.ITEMS.register(item);
		MinecraftServer server = FMLCommonHandler.instance().getMinecraftServerInstance();
		if (server != null && server.worlds.length > 0) {
			World world = server.worlds[0];
			if (!world.isRemote) {
				try {
					registerFluidModel();
				} catch (Exception e) {
				}
			}
		} else if (server == null) {
			try {
				registerFluidModel();
			} catch (Exception e) {
			}
		}
	}

	@SideOnly(Side.CLIENT)
	public void registerFluidModel() {
		Item item = Item.getItemFromBlock(block);
		ModelBakery.registerItemVariants(item);
		ModelLoader.setCustomMeshDefinition(item, new ItemMeshDefinition() {

			@Override
			public ModelResourceLocation getModelLocation(ItemStack stack) {
				return new ModelResourceLocation("testenvironmentmod:bucketofthunder", "bucketofthunder");
			}
		});
		ModelLoader.setCustomStateMapper(block, new StateMapperBase() {

			@Override
			protected ModelResourceLocation getModelResourceLocation(IBlockState state) {
				return new ModelResourceLocation("testenvironmentmod:bucketofthunder", "bucketofthunder");
			}
		});
	}

	public void load(FMLInitializationEvent event) {
	}

	public void generateNether(World world, Random random, int chunkX, int chunkZ) {
	}

	public void generateSurface(World world, Random random, int chunkX, int chunkZ) {
	}

	public int addFuel(ItemStack fuel) {
		return 0;
	}

	public void registerRenderers() {
	}

	public void serverLoad(FMLServerStartingEvent event) {
	}
}
