package mod.mcreator;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.ForgeRegistries;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;

import net.minecraft.world.gen.feature.WorldGenMinable;
import net.minecraft.world.World;
import net.minecraft.world.IBlockAccess;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.Item;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.Minecraft;
import net.minecraft.block.state.IBlockState;
import net.minecraft.block.material.Material;
import net.minecraft.block.SoundType;
import net.minecraft.block.Block;

import java.util.Random;
import java.util.HashMap;

public class mcreator_blockthree {

	public mcreator_blockthree() {
	}

	public static BlockBlockthree block;
	public static Item item;
	public static Object instance;

	public int addFuel(ItemStack fuel) {
		return 0;
	}

	public void serverLoad(FMLServerStartingEvent event) {
	}

	public void preInit(FMLPreInitializationEvent event) {
		block.setRegistryName("blockthree");
		ForgeRegistries.BLOCKS.register(block);
		item = new ItemBlock(block).setRegistryName(block.getRegistryName());
		ForgeRegistries.ITEMS.register(item);
	}

	public void registerRenderers() {
	}

	public void load(FMLInitializationEvent event) {
		if (event.getSide() == Side.CLIENT) {
			Minecraft.getMinecraft().getRenderItem().getItemModelMesher()
					.register(item, 0, new ModelResourceLocation("testenvironmentmod:blockthree", "inventory"));
		}
	}

	static {
		block = (BlockBlockthree) (new BlockBlockthree().setHardness(17.0F).setResistance(15.5F).setLightLevel(1.0F).setUnlocalizedName("blockthree")
				.setLightOpacity(81).setCreativeTab(mcreator_tabsone.tab));
		block.setHarvestLevel("pickaxe", 5);
	}

	public void generateSurface(World world, java.util.Random rand, int chunkX, int chunkZ) {
		for (int i = 0; i < 7; i++) {
			int randPosX = chunkX + rand.nextInt(16);
			int randPosY = rand.nextInt(100) + 10;
			int randPosZ = chunkZ + rand.nextInt(16);
			(new WorldGenMinable(mcreator_blockthree.block.getDefaultState(), 7)).generate(world, rand, new BlockPos(randPosX, randPosY, randPosZ));
		}
	}

	public void generateNether(World world, java.util.Random rand, int chunkX, int chunkZ) {
		for (int i = 0; i < 7; i++) {
			int randPosX = chunkX + rand.nextInt(16);
			int randPosY = rand.nextInt(100) + 10;
			int randPosZ = chunkZ + rand.nextInt(16);
			(new WorldGenMinable(mcreator_blockthree.block.getDefaultState(), 7)).generate(world, rand, new BlockPos(randPosX, randPosY, randPosZ));
		}
	}

	static class BlockBlockthree extends Block {

		int a1 = 0, a2 = 0, a3 = 0, a4 = 0, a5 = 0, a6 = 0;
		boolean red = false;

		protected BlockBlockthree() {
			super(Material.ROCK);
			setSoundType(SoundType.CLOTH);
		}

		@Override
		public void onBlockAdded(World world, BlockPos pos, IBlockState state) {
			int i = pos.getX();
			int j = pos.getY();
			int k = pos.getZ();
			world.scheduleUpdate(new BlockPos(i, j, k), this, this.tickRate(world));
		}

		@Override
		public int getWeakPower(IBlockState blockState, IBlockAccess blockAccess, BlockPos pos, EnumFacing side) {
			return red ? 15 : 0;
		}

		@Override
		public int getStrongPower(IBlockState blockState, IBlockAccess blockAccess, BlockPos pos, EnumFacing side) {
			return red ? 15 : 0;
		}

		@Override
		public void onEntityCollidedWithBlock(World world, BlockPos pos, IBlockState state, Entity entity) {
			int i = pos.getX();
			int j = pos.getY();
			int k = pos.getZ();
			java.util.HashMap<String, Object> dependencies = new java.util.HashMap<>();
			dependencies.put("x", i);
			dependencies.put("y", j);
			dependencies.put("z", k);
			dependencies.put("world", world);
			dependencies.put("entity", entity);
			dependencies.put("block", block);
			mcreator_weakexplosion.executeProcedure(dependencies);
		}

		@Override
		public void onBlockPlacedBy(World world, BlockPos pos, IBlockState state, EntityLivingBase entity, ItemStack itemstack) {
			int i = pos.getX();
			int j = pos.getY();
			int k = pos.getZ();
			java.util.HashMap<String, Object> dependencies = new java.util.HashMap<>();
			dependencies.put("x", i);
			dependencies.put("y", j);
			dependencies.put("z", k);
			dependencies.put("world", world);
			dependencies.put("entity", entity);
			dependencies.put("block", block);
			dependencies.put("itemstack", itemstack);
			mcreator_lightningbolt.executeProcedure(dependencies);
		}

		@SideOnly(Side.CLIENT)
		@Override
		public BlockRenderLayer getBlockLayer() {
			return BlockRenderLayer.SOLID;
		}

		@Override
		public AxisAlignedBB getBoundingBox(IBlockState state, IBlockAccess source, BlockPos pos) {
			return new AxisAlignedBB(0.0D, 0.0D, 0.0D, 1.0D, 1.0D, 1.0D);
		}

		@Override
		public boolean canConnectRedstone(IBlockState state, IBlockAccess world, BlockPos pos, EnumFacing side) {
			return true;
		}

		@Override
		public boolean canProvidePower(IBlockState state) {
			return true;
		}

		@Override
		public int tickRate(World world) {
			return 10;
		}

		@Override
		public int quantityDropped(Random par1Random) {
			return 1;
		}
	}
}
